/*
compile with

gcc gtktextview.c -o gtktextview `pkg-config --cflags --libs gtk+-directfb-2.0`
*/

#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/wait.h>

/* Another callback */
static void destroy( GtkWidget *widget,
                     gpointer   data )
{
    gtk_main_quit ();
}

static gboolean delete_event( GtkWidget *widget,
                              GdkEvent  *event,
                              gpointer   data )
{
    return FALSE;
} 

void reload_gtkrc_callback(GtkWidget *button, GtkWidget *window )
{
    gtk_rc_reparse_all();
}

int main( int   argc, char *argv[] )
{

    GtkWidget *window, *view, *button, *hbox, *vbox, *buttonbox;
    GtkTextBuffer *buffer;
   
    gtk_init (&argc, &argv);
            
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (delete_event), NULL);
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (destroy), NULL);
    gtk_widget_set_size_request (window, 640, 480);
    
    view = gtk_text_view_new ();
    buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
    gtk_text_buffer_set_text (buffer, "You can type some text inside this GTKTextView", -1);

	buttonbox = gtk_hbox_new (TRUE, 5);
	button = gtk_button_new_with_label("Reload gtkrc");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (reload_gtkrc_callback), G_OBJECT (window));
    gtk_box_pack_start(GTK_BOX(buttonbox), button, TRUE, TRUE, 5); 
   	button = gtk_button_new_with_label("Quit");
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy), G_OBJECT (window));
    gtk_box_pack_start(GTK_BOX(buttonbox), button, TRUE, TRUE, 5); 

    vbox = gtk_vbox_new (FALSE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), view, TRUE, TRUE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), buttonbox, FALSE, TRUE, 5);
    hbox = gtk_hbox_new (FALSE, 5);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 5);
    
    gtk_container_add(GTK_CONTAINER(window), hbox);

    gtk_widget_show_all (window);

    gtk_main ();
    
    return 0;
}
